function addMoney(line){
    var gm = new CGame({
        win_occurrence: parseInt(Settings.winRate),        //WIN PERCENTAGE.SET A VALUE FROM 0 TO 100.
        slot_cash: 1000,          //THIS IS THE CURRENT SLOT CASH AMOUNT. THE GAME CHECKS IF THERE IS AVAILABLE CASH FOR WINNINGS.
        min_reel_loop:2,          //NUMBER OF REEL LOOPS BEFORE SLOT STOPS
        reel_delay: 6,            //NUMBER OF FRAMES TO DELAY THE REELS THAT START AFTER THE FIRST ONE
        time_show_win:2000,       //DURATION IN MILLISECONDS OF THE WINNING COMBO SHOWING
        time_show_all_wins: 2000, //DURATION IN MILLISECONDS OF ALL WINNING COMBO
        money: (appsgeyser.data.getItem('money'))? appsgeyser.data.getItem('money') : parseInt(Settings.money) ,               //STARING CREDIT FOR THE USER
        ad_show_counter:3         //NUMBER OF SPIN PLAYED BEFORE AD SHOWING

    });
    gm.addMoney(line);
}
function CGame(oData) {
    var _bUpdate = false;
    var _iCurState;
    var _iCurReelLoops;
    var _iNextColToStop;
    var _iNumReelsStopped;
    var _iLastLineActive;
    var _iTimeElaps;
    var _iCurWinShown;
    var _iCurBet;
    var _iTotBet;
    var _iMoney;
    var _iTotWin;
    var _iNumSpinCont;
    var _iAdsShowingCont;
    var _aMovingColumns;
    var _aStaticSymbols;
    var _aWinningLine;
    var _aReelSequence;
    var _aFinalSymbolCombo;
    var _oReelSound;
    var _oCurSymbolWinSound;
    var _oBg;
    var _oFrontSkin;
    var _oInterface;
    var _oPayTable = null;

    this._init = function () {
        _iCurState = GAME_STATE_IDLE;
        _iCurReelLoops = 0;
        _iNumReelsStopped = 0;
        _iNumSpinCont = 0;
        _aReelSequence = new Array(0, 1, 2, 3, 4);
        _iNextColToStop = _aReelSequence[0];
        _iLastLineActive = NUM_PAYLINES;
        _iMoney = TOTAL_MONEY;
        _iCurBet = MIN_BET;
        _iTotBet = _iCurBet * _iLastLineActive;

        s_oTweenController = new CTweenController();

        var sss = new createjs.Shape();
        sss.graphics.beginFill('#'+Settings.colorBackground);
        sss.alpha = 1;
        sss.graphics.drawRoundRect(0, 0, CANVAS_WIDTH , CANVAS_HEIGHT, 20,20,20,20);
        sss.graphics.endFill();
        sss.x = 0;
        sss.y = 0;
        s_oStage.addChild(sss);
        //_oBg = createBitmap(s_oSpriteLibrary.getSprite('bg_game'));
        //s_oStage.addChild(_oBg);

        this._initReels();

        _oInterface = new CInterface(_iCurBet, _iTotBet, _iMoney);
        this._initStaticSymbols();
        _oPayTable = new CPayTablePanel();
        if (_iMoney < _iTotBet) {
            if(confirm('You have '+_iMoney+' coins. Watch advertisement video and get 200 coins!')){
                if('AppsgeyserJSInterface' in window){
                    AppsgeyserJSInterface.showAdColonyVideoAd("{'app_id':'app1d4ca5f8f68d475f95', 'client_options': 'version:1.0,store:google', 'zone_id': 'vze80d2184268c4fa78f'}", "addMoney");
                }
            }
        }


        _bUpdate = true;
    };

    this.unload = function () {
        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
            createjs.Sound.stop();
        }

        _oInterface.unload();
        _oPayTable.unload();

        for (var k = 0; k < _aMovingColumns.length; k++) {
            _aMovingColumns[k].unload();
        }

        for (var i = 0; i < NUM_ROWS; i++) {
            for (var j = 0; j < NUM_REELS; j++) {
                _aStaticSymbols[i][j].unload();
            }
        }

        s_oStage.removeAllChildren();
    };

    this._initReels = function () {
        var iXPos = REEL_OFFSET_X;
        var iYPos = REEL_OFFSET_Y;
        var _oFrontSkinY;

        _oFrontSkin = new createjs.Bitmap(s_oSpriteLibrary.getSprite('bg_menu'));
        s_oStage.addChild(_oFrontSkin);

        var iCurDelay = 0;
        _aMovingColumns = new Array();
        for (var i = 0; i < NUM_REELS; i++) {
            _aMovingColumns[i] = new CReelColumn(i, iXPos, iYPos, iCurDelay);
            _aMovingColumns[i + NUM_REELS] = new CReelColumn(i + NUM_REELS, iXPos, iYPos + (SYMBOL_SIZE * NUM_ROWS), iCurDelay);
            iXPos += SYMBOL_SIZE + SPACE_BETWEEN_SYMBOLS;
            iCurDelay += REEL_DELAY;
        }

        var crop_bottom = new createjs.Bitmap(s_oSpriteLibrary.getSprite('bg_menu'));
        crop_bottom.sourceRect = { x:0, y: CANVAS_HEIGHT - 130, width:crop_bottom.image.width, height:130 };
        crop_bottom.y = CANVAS_HEIGHT - 130;

        var crop_top = new createjs.Bitmap(s_oSpriteLibrary.getSprite('bg_menu'));
        crop_top.sourceRect = { x:0, y: 0, width:crop_top.image.width, height:80 };
        crop_top.y = 0;

        s_oStage.addChild(crop_top);
        s_oStage.addChild(crop_bottom);
    };

    this.addMoney = function(line){
        var json = JSON.parse(line);
        if(json.noFill){
            if(json.action !== 'start'){
                if(json.amount == undefined){
                    console.log(json.shown);
                    if(json.shown === 'false'){
                        if(json.canceled === 'false'){
                            if(confirm('Error occurred, try again ?')){
                                if('AppsgeyserJSInterface' in window){
                                    AppsgeyserJSInterface.showAdColonyVideoAd("{'app_id':'app1d4ca5f8f68d475f95', 'client_options': 'version:1.0,store:google', 'zone_id': 'vze80d2184268c4fa78f'}", "addMoney");
                                }
                            } else {
                                appsgeyser.data.setItem('money', _iMoney);
                                location.reload();
                            }
                        }
                    }
                }
            }
        } else {
            if(json.amount !== undefined){
                appsgeyser.data.setItem('money', 200);
                location.reload();
            }
        }
    };

    this._initStaticSymbols = function () {
        var iXPos = REEL_OFFSET_X;
        var iYPos = REEL_OFFSET_Y;
        _aStaticSymbols = new Array();
        for (var i = 0; i < NUM_ROWS; i++) {
            _aStaticSymbols[i] = new Array();
            for (var j = 0; j < NUM_REELS; j++) {
                var oSymbol = new CStaticSymbolCell(i, j, iXPos, iYPos);
                _aStaticSymbols[i][j] = oSymbol;

                iXPos += SYMBOL_SIZE + SPACE_BETWEEN_SYMBOLS;
            }
            iXPos = REEL_OFFSET_X;
            iYPos += SYMBOL_SIZE;
        }
    };

    this.generateFinalSymbols = function () {
        _aFinalSymbolCombo = new Array();
        for (var i = 0; i < NUM_ROWS; i++) {
            _aFinalSymbolCombo[i] = new Array();
            for (var j = 0; j < NUM_REELS; j++) {
                var iRandIndex = Math.floor(Math.random() * s_aRandSymbols.length);
                var iRandSymbol = s_aRandSymbols[iRandIndex];

                _aFinalSymbolCombo[i][j] = iRandSymbol;
            }
        }

        //CHECK IF THERE IS ANY COMBO
        _aWinningLine = new Array();
        _iTotWin = 0;
        for (var k = 0; k < _iLastLineActive; k++) {
            var aCombos = s_aPaylineCombo[k];

            var aCellList = new Array();
            var iValue = _aFinalSymbolCombo[aCombos[0].row][aCombos[0].col];
            var iNumEqualSymbol = 1;
            var iStartIndex = 1;
            aCellList.push({
                row: aCombos[0].row,
                col: aCombos[0].col,
                value: _aFinalSymbolCombo[aCombos[0].row][aCombos[0].col]
            });

            while (iValue === WILD_SYMBOL && iStartIndex < NUM_REELS) {
                iNumEqualSymbol++;
                iValue = _aFinalSymbolCombo[aCombos[iStartIndex].row][aCombos[iStartIndex].col];
                aCellList.push({
                    row: aCombos[iStartIndex].row, col: aCombos[iStartIndex].col,
                    value: _aFinalSymbolCombo[aCombos[iStartIndex].row][aCombos[iStartIndex].col]
                });
                iStartIndex++;
            }

            for (var t = iStartIndex; t < aCombos.length; t++) {
                if (_aFinalSymbolCombo[aCombos[t].row][aCombos[t].col] === iValue ||
                    _aFinalSymbolCombo[aCombos[t].row][aCombos[t].col] === WILD_SYMBOL) {
                    iNumEqualSymbol++;

                    aCellList.push({
                        row: aCombos[t].row,
                        col: aCombos[t].col,
                        value: _aFinalSymbolCombo[aCombos[t].row][aCombos[t].col]
                    });
                } else {
                    break;
                }
            }

            if (s_aSymbolWin[iValue - 1][iNumEqualSymbol - 1] > 0) {
                _iTotWin += s_aSymbolWin[iValue - 1][iNumEqualSymbol - 1];
                _aWinningLine.push({
                    line: k + 1, amount: s_aSymbolWin[iValue - 1][iNumEqualSymbol - 1],
                    num_win: iNumEqualSymbol, value: iValue, list: aCellList
                });
            }
        }

        return _aWinningLine.length > 0 ? true : false;
    };

    this._generateRandSymbols = function () {
        var aRandSymbols = new Array();
        for (var i = 0; i < NUM_ROWS; i++) {
            var iRandIndex = Math.floor(Math.random() * s_aRandSymbols.length);
            aRandSymbols[i] = s_aRandSymbols[iRandIndex];
        }

        return aRandSymbols;
    };

    this.reelArrived = function (iReelIndex, iCol) {
        if (_iCurReelLoops > MIN_REEL_LOOPS) {
            if (_iNextColToStop === iCol) {
                if (_aMovingColumns[iReelIndex].isReadyToStop() === false) {
                    var iNewReelInd = iReelIndex;
                    if (iReelIndex < NUM_REELS) {
                        iNewReelInd += NUM_REELS;

                        _aMovingColumns[iNewReelInd].setReadyToStop();

                        _aMovingColumns[iReelIndex].restart(new Array(_aFinalSymbolCombo[0][iReelIndex],
                            _aFinalSymbolCombo[1][iReelIndex],
                            _aFinalSymbolCombo[2][iReelIndex]), true);

                    } else {
                        iNewReelInd -= NUM_REELS;
                        _aMovingColumns[iNewReelInd].setReadyToStop();

                        _aMovingColumns[iReelIndex].restart(new Array(_aFinalSymbolCombo[0][iNewReelInd],
                            _aFinalSymbolCombo[1][iNewReelInd],
                            _aFinalSymbolCombo[2][iNewReelInd]), true);


                    }

                }
            } else {
                _aMovingColumns[iReelIndex].restart(this._generateRandSymbols(), false);
            }

        } else {

            _aMovingColumns[iReelIndex].restart(this._generateRandSymbols(), false);
            if (iReelIndex === 0) {
                _iCurReelLoops++;
            }

        }
    };

    this.stopNextReel = function () {
        _iNumReelsStopped++;

        if (_iNumReelsStopped % 2 === 0) {

            playSound("reel_stop", 1, 0);

            _iNextColToStop = _aReelSequence[_iNumReelsStopped / 2];
            if (_iNumReelsStopped === (NUM_REELS * 2)) {
                this._endReelAnimation();
            }
        }
    };

    this._endReelAnimation = function () {
        if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
            _oReelSound.stop();
        }

        _oInterface.disableBetBut(false);

        _iCurReelLoops = 0;
        _iNumReelsStopped = 0;
        _iNextColToStop = _aReelSequence[0];

        //var iTotWin = 0;
        //INCREASE MONEY IF THERE ARE COMBOS
        if (_aWinningLine.length > 0) {
            //HIGHLIGHT WIN COMBOS IN PAYTABLE
            for (var i = 0; i < _aWinningLine.length; i++) {
                _oPayTable.highlightCombo(_aWinningLine[i].value, _aWinningLine[i].num_win);
                _oInterface.showLine(_aWinningLine[i].line);
                var aList = _aWinningLine[i].list;
                for (var k = 0; k < aList.length; k++) {
                    _aStaticSymbols[aList[k].row][aList[k].col].show(aList[k].value);
                }

                //iTotWin += _aWinningLine[i].amount;
            }

            _iTotWin *= _iCurBet;
            _iMoney += _iTotWin;
            SLOT_CASH -= _iTotWin;

            if (_iTotWin > 0) {
                appsgeyser.data.setItem('money', _iMoney);
                _oInterface.refreshMoney(_iMoney);
                _oInterface.refreshWinText(_iTotWin);
            }

            _iTimeElaps = 0;
            _iCurState = GAME_STATE_SHOW_ALL_WIN;

            if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
                _oCurSymbolWinSound = playSound("win", 0.3, 0);
            }
        } else {
            _iCurState = GAME_STATE_IDLE;
        }

        _oInterface.enableGuiButtons();

        // TODO SAVE MONEY
        if (_iMoney < _iTotBet) {
            if(confirm('You have '+_iMoney+' coins. Watch advertisement video and get 200 coins!')){
                if('AppsgeyserJSInterface' in window){
                    AppsgeyserJSInterface.showAdColonyVideoAd("{'app_id':'app1d4ca5f8f68d475f95', 'client_options': 'version:1.0,store:google', 'zone_id': 'vze80d2184268c4fa78f'}", "addMoney");
                }
            }
        }

        _iNumSpinCont++;
        if (_iNumSpinCont === _iAdsShowingCont) {
            _iNumSpinCont = 0;

            $(s_oMain).trigger("show_interlevel_ad");
        }

        appsgeyser.data.setItem('money',_iMoney);
        $(s_oMain).trigger("save_score", _iMoney);
    };

    this.hidePayTable = function () {
        _oPayTable.hide();
    };

    this._showWin = function () {
        var iLineIndex;
        if (_iCurWinShown > 0) {
            stopSound(_oCurSymbolWinSound);


            iLineIndex = _aWinningLine[_iCurWinShown - 1].line;
            _oInterface.hideLine(iLineIndex);

            var aList = _aWinningLine[_iCurWinShown - 1].list;
            for (var k = 0; k < aList.length; k++) {
                _aStaticSymbols[aList[k].row][aList[k].col].stopAnim();
            }
        }

        if (_iCurWinShown === _aWinningLine.length) {
            _iCurWinShown = 0;
        }

        iLineIndex = _aWinningLine[_iCurWinShown].line;
        _oInterface.showLine(iLineIndex);

        var aList = _aWinningLine[_iCurWinShown].list;
        for (var k = 0; k < aList.length; k++) {
            _aStaticSymbols[aList[k].row][aList[k].col].show(aList[k].value);
        }


        _iCurWinShown++;

    };

    this._hideAllWins = function () {
        for (var i = 0; i < _aWinningLine.length; i++) {
            var aList = _aWinningLine[i].list;
            for (var k = 0; k < aList.length; k++) {
                _aStaticSymbols[aList[k].row][aList[k].col].stopAnim();
            }
        }

        _oInterface.hideAllLines();

        _iTimeElaps = 0;
        _iCurWinShown = 0;
        _iTimeElaps = TIME_SHOW_WIN;
        _iCurState = GAME_STATE_SHOW_WIN;
    };

    this.activateLines = function (iLine) {
        _iLastLineActive = iLine;
        this.removeWinShowing();

        var iNewTotalBet = _iCurBet * _iLastLineActive;

        _iTotBet = iNewTotalBet;
        _oInterface.refreshTotalBet(_iTotBet);
        _oInterface.refreshNumLines(_iLastLineActive);


        if (iNewTotalBet > _iMoney) {
            if(confirm('You have '+_iMoney+' coins. Watch advertisement video and get 200 coins!')){
                if('AppsgeyserJSInterface' in window){
                    AppsgeyserJSInterface.showAdColonyVideoAd("{'app_id':'app1d4ca5f8f68d475f95', 'client_options': 'version:1.0,store:google', 'zone_id': 'vze80d2184268c4fa78f'}", "addMoney");
                }
            }
        } else {
            _oInterface.enableSpin();
        }
    };

    this.addLine = function () {
        if (_iLastLineActive === NUM_PAYLINES) {
            _iLastLineActive = 1;
        } else {
            _iLastLineActive++;
        }

        var iNewTotalBet = _iCurBet * _iLastLineActive;

        _iTotBet = iNewTotalBet;
        console.log(_iTotBet);
        _oInterface.refreshTotalBet(_iTotBet);
        _oInterface.refreshNumLines(_iLastLineActive);


        if (iNewTotalBet > _iMoney) {
            if(confirm('You have '+_iMoney+' coins. Watch advertisement video and get 200 coins!')){
                if('AppsgeyserJSInterface' in window){
                    AppsgeyserJSInterface.showAdColonyVideoAd("{'app_id':'app1d4ca5f8f68d475f95', 'client_options': 'version:1.0,store:google', 'zone_id': 'vze80d2184268c4fa78f'}", "addMoney");
                }
            }
        } else {
            _oInterface.enableSpin();
        }
    };

    this.changeCoinBet = function () {
        var iNewBet = Math.floor((_iCurBet + 0.05) * 100) / 100;
        var iNewTotalBet;

        if (iNewBet > MAX_BET) {
            _iCurBet = MIN_BET;
            _iTotBet = _iCurBet * _iLastLineActive;
            _oInterface.refreshBet(_iCurBet);
            _oInterface.refreshTotalBet(_iTotBet);
            iNewTotalBet = _iTotBet;
        } else {
            iNewTotalBet = iNewBet * _iLastLineActive;

            _iCurBet += 0.05;
            _iCurBet = Math.floor(_iCurBet * 100) / 100;
            _iTotBet = iNewTotalBet;
            _oInterface.refreshBet(_iCurBet);
            _oInterface.refreshTotalBet(_iTotBet);
        }

        if (iNewTotalBet > _iMoney) {
            if(confirm('You have '+_iMoney+' coins. Watch advertisement video and get 200 coins!')){
                if('AppsgeyserJSInterface' in window){
                    AppsgeyserJSInterface.showAdColonyVideoAd("{'app_id':'app1d4ca5f8f68d475f95', 'client_options': 'version:1.0,store:google', 'zone_id': 'vze80d2184268c4fa78f'}", "addMoney");
                }
            }
        } else {
            _oInterface.enableSpin();
        }

    };

    this.onMaxBet = function () {
        var iNewBet = MAX_BET;
        _iLastLineActive = NUM_PAYLINES;

        var iNewTotalBet = iNewBet * _iLastLineActive;

        _iCurBet = MAX_BET;
        _iTotBet = iNewTotalBet;
        _oInterface.refreshBet(_iCurBet);
        _oInterface.refreshTotalBet(_iTotBet);
        _oInterface.refreshNumLines(_iLastLineActive);

        if (iNewTotalBet > _iMoney) {
            if(confirm('You have '+_iMoney+' coins. Watch advertisement video and get 200 coins!')){
                if('AppsgeyserJSInterface' in window){
                    AppsgeyserJSInterface.showAdColonyVideoAd("{'app_id':'app1d4ca5f8f68d475f95', 'client_options': 'version:1.0,store:google', 'zone_id': 'vze80d2184268c4fa78f'}", "addMoney");
                }
            }
        } else {
            _oInterface.enableSpin();
            this.onSpin();
        }
    };

    this.removeWinShowing = function () {
        _oPayTable.resetHighlightCombo();

        _oInterface.resetWin();

        for (var i = 0; i < NUM_ROWS; i++) {
            for (var j = 0; j < NUM_REELS; j++) {
                _aStaticSymbols[i][j].hide();
            }
        }

        for (var k = 0; k < _aMovingColumns.length; k++) {
            _aMovingColumns[k].activate();
        }

        _iCurState = GAME_STATE_IDLE;
    };

    this.onSpin = function () {
        var iNewBet = _iCurBet;
        _iLastLineActive = NUM_PAYLINES;

        var iNewTotalBet = iNewBet * _iLastLineActive;

        if (iNewTotalBet > _iMoney) {
            if(confirm('You have '+_iMoney+' coins. Watch advertisement video and get 200 coins!')){
                if('AppsgeyserJSInterface' in window){
                    AppsgeyserJSInterface.showAdColonyVideoAd("{'app_id':'app1d4ca5f8f68d475f95', 'client_options': 'version:1.0,store:google', 'zone_id': 'vze80d2184268c4fa78f'}", "addMoney");
                }
            }
        } else {
            if (DISABLE_SOUND_MOBILE === false || s_bMobile === false) {
                if (_oCurSymbolWinSound) {
                    stopSound(_oCurSymbolWinSound);
                }
                _oReelSound = playSound("reels", 1, 0);
            }


            _oInterface.disableBetBut(true);
            this.removeWinShowing();

            //FIND MIN WIN
            MIN_WIN = s_aSymbolWin[0][s_aSymbolWin[0].length - 1];
            for (var i = 0; i < s_aSymbolWin.length; i++) {
                var aTmp = s_aSymbolWin[i];
                for (var j = 0; j < aTmp.length; j++) {
                    if (aTmp[j] !== 0 && aTmp[j] < MIN_WIN) {
                        MIN_WIN = aTmp[j];
                    }
                }
            }

            MIN_WIN *= _iCurBet;

            _iMoney -= _iTotBet;
            _oInterface.refreshMoney(_iMoney);
            SLOT_CASH += _iTotBet;
            //CHECK IF THERE IS MINIMUM AMOUNT FOR AT LEAST WORST WINNING
            if (SLOT_CASH < MIN_WIN) {
                //PLAYER MUST LOSE
                do {
                    var bRet = this.generateFinalSymbols();
                } while (bRet === true);
            } else {
                //RANDOM TO ASSIGN A WIN OR NOT
                var iRandSpin = Math.floor(Math.random() * 101);

                if (iRandSpin > WIN_OCCURRENCE) {
                    //PLAYER LOSES
                    do {
                        var bRet = this.generateFinalSymbols();
                    } while (bRet === true);
                } else {
                    //PLAYER WINS
                    do {
                        var bRet = this.generateFinalSymbols();
                    } while (bRet === false || (_iTotWin * _iCurBet) > SLOT_CASH);
                }
            }


            _oInterface.hideAllLines();
            _oInterface.disableGuiButtons();


            _iCurState = GAME_STATE_SPINNING;
        }
    };

    this.onInfoClicked = function () {
        if (_iCurState === GAME_STATE_SPINNING) {
            return;
        }

        if (_oPayTable.isVisible()) {
            _oPayTable.hide();
        } else {
            _oPayTable.show();
        }
    };

    this.onExit = function () {
        //this.unload();
        location.reload();
        $(s_oMain).trigger("end_session");
        $(s_oMain).trigger("share_event", _iMoney);

        s_oMain.gotoMenu();
    };

    this.getState = function () {
        return _iCurState;
    };

    this.update = function () {
        if (_bUpdate === false) {
            return;
        }

        switch (_iCurState) {
            case GAME_STATE_SPINNING:
            {
                for (var i = 0; i < _aMovingColumns.length; i++) {
                    _aMovingColumns[i].update();
                }
                break;
            }
            case GAME_STATE_SHOW_ALL_WIN:
            {
                _iTimeElaps += s_iTimeElaps;
                if (_iTimeElaps > TIME_SHOW_ALL_WINS) {
                    this._hideAllWins();
                }
                break;
            }
            case GAME_STATE_SHOW_WIN:
            {
                _iTimeElaps += s_iTimeElaps;
                if (_iTimeElaps > TIME_SHOW_WIN) {
                    _iTimeElaps = 0;

                    this._showWin();
                }
                break;
            }
        }


    };

    s_oGame = this;

    WIN_OCCURRENCE = oData.win_occurrence;
    MIN_REEL_LOOPS = oData.min_reel_loop;
    REEL_DELAY = oData.reel_delay;
    TIME_SHOW_WIN = oData.time_show_win;
    TIME_SHOW_ALL_WINS = oData.time_show_all_wins;
    TOTAL_MONEY = (appsgeyser.data.getItem('money'))? appsgeyser.data.getItem('money') : oData.money;

    SLOT_CASH = oData.slot_cash;
    _iAdsShowingCont = oData.ad_show_counter;
}

var s_oGame;
var s_oTweenController;